## scantailor 0.9.9

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0)

IF(COMMAND cmake_policy)
	# Suppress warnings.
	cmake_policy(SET CMP0003 NEW)
ENDIF(COMMAND cmake_policy)

SET(
	CMAKE_USER_MAKE_RULES_OVERRIDE
	"${CMAKE_SOURCE_DIR}/cmake/default_cflags.cmake"
)
SET(
	CMAKE_USER_MAKE_RULES_OVERRIDE_CXX
	"${CMAKE_SOURCE_DIR}/cmake/default_cxxflags.cmake"
)

PROJECT("Scan Tailor")

# This forces Visual Studio 2008 SP1 to actually link to the versions of the
# libraries it ships with!  It's harmless on other platforms.
ADD_DEFINITIONS(-D_BIND_TO_CURRENT_VCLIBS_VERSION=1)

ENABLE_TESTING()

# An undocumented side-effect of CONFIGURE_FILE() is that it makes
# the whole project depend on the file we are parsing / copying.
CONFIGURE_FILE(
	"${PROJECT_SOURCE_DIR}/version.h"
	"${PROJECT_BINARY_DIR}/.version.h" COPYONLY
)

# Prevent this leftover from old builds to be used in favour
# of the one in ${PROJECT_SOURCE_DIR}
IF(NOT "${PROJECT_BINARY_DIR}" STREQUAL "${PROJECT_SOURCE_DIR}")
	FILE(REMOVE "${PROJECT_BINARY_DIR}/version.h")
ENDIF()

# Extract VERSION and VERSION_QUAD from version.h
FILE(READ "${PROJECT_SOURCE_DIR}/version.h" version_h_contents)
STRING(
	REGEX REPLACE
	".*#define[ \\t]+VERSION[ \\t]+\"([^\"]*)\".*"
	"\\1" VERSION "${version_h_contents}"
)
IF("${VERSION}" STREQUAL "${version_h_contents}")
	MESSAGE(FATAL_ERROR "Failed to extract VERSION from version.h")
ENDIF()

# VERSION_QUAD must be either empty or be in the form of X.Y.Z.Y
STRING(
	REGEX REPLACE
	".*#define[ \\t]+VERSION_QUAD[ \\t]+\"(([0-9]+\\.[0-9]+\\.[0-9]+\\.[0-9]+)?)\".*"
	"\\1" VERSION_QUAD "${version_h_contents}"
)
IF("${VERSION_QUAD}" STREQUAL "${version_h_contents}")
	MESSAGE(FATAL_ERROR "Failed to extract VERSION_QUAD from version.h")
ENDIF()

INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFileCXX)
INCLUDE(FindBoost)
INCLUDE(cmake/FindPthreads.cmake)
INCLUDE(cmake/SetDefaultBuildType.cmake)
INCLUDE(cmake/SetDefaultGccFlags.cmake)
INCLUDE(cmake/ToNativePath.cmake)
INCLUDE(cmake/UpdateTranslations.cmake)

ST_SET_DEFAULT_BUILD_TYPE(Release)
IF(CMAKE_COMPILER_IS_GNUCC)
	ST_SET_DEFAULT_GCC_FLAGS()
ENDIF(CMAKE_COMPILER_IS_GNUCC)

GET_FILENAME_COMPONENT(outer_dir "${PROJECT_SOURCE_DIR}/.." ABSOLUTE)

IF(WIN32 AND NOT QT_QMAKE_EXECUTABLE)
	FILE(GLOB qt_dirs "${outer_dir}/qt-win-*-4.[0-9]*")
	FILE(GLOB qt_dirs2 "C:/Qt/4.*.*")
	FILE(GLOB qt_dirs3 "C:/Qt/20*/qt")
	FIND_PROGRAM(
		QT_QMAKE_EXECUTABLE qmake
		PATHS dummy_dir ${qt_dirs} ${qt_dirs2} ${qt_dirs3}
		PATH_SUFFIXES bin
	)
ENDIF(WIN32 AND NOT QT_QMAKE_EXECUTABLE)

INCLUDE(FindQt4)
IF(NOT QT4_FOUND)
	MESSAGE(
		FATAL_ERROR "Qt4 could not be found. "
		"If it's installed in a non-standard location, specify the path to qmake in QT_QMAKE_EXECUTABLE. "
		"You can do it in interactive mode (ccmake instead of cmake) or using -DVAR=VAL syntax."
	)
ENDIF(NOT QT4_FOUND)


INCLUDE(FindOpenGL)
SET(use_opengl OFF)
IF(OPENGL_FOUND AND QT_QTOPENGL_FOUND)
	# Disabled for now due to various problems associated with it.
	# SET(use_opengl ON)
ENDIF()
OPTION(ENABLE_OPENGL "OpenGL may be used for UI acceleration" ${use_opengl})


FILE(GLOB jpeg_dirs "${outer_dir}/jpeg-[0-9]*")
FILE(GLOB zlib_dirs "${outer_dir}/zlib-[0-9]*.[0-9]*.[0-9]*")
FILE(GLOB png_dirs "${outer_dir}/libpng-[0-9]*.[0-9]*.[0-9]*")
FILE(GLOB tiff_dirs "${outer_dir}/tiff-[0-9]*.[0-9]*.[0-9]*")
FILE(GLOB boost_dirs "${outer_dir}/boost_1_[0-9]*_[0-9]*")

FIND_PATH(
	JPEG_INCLUDE_DIR jpeglib.h
	PATHS /usr/local/include /usr/include ${jpeg_dirs}
	DOC "Path to libjpeg headers."
)
IF(NOT JPEG_INCLUDE_DIR)
	MESSAGE(
		FATAL_ERROR
		"Could not find jpeg headers.\n"
		"You may need to install a package named libjpeg62-dev or similarly."
	)
ENDIF(NOT JPEG_INCLUDE_DIR)

FIND_LIBRARY(
	JPEG_LIBRARY NAMES jpeg libjpeg.lib
	PATHS /usr/local/lib /usr/lib ${jpeg_dirs}
	DOC "Path to jpeg library."
)
INCLUDE_DIRECTORIES("${JPEG_INCLUDE_DIR}")

FIND_PATH(
	ZLIB_INCLUDE_DIR zlib.h
	PATHS /usr/local/include /usr/include ${zlib_dirs}
	DOC "Path to zlib headers."
)
IF(NOT ZLIB_INCLUDE_DIR)
	MESSAGE(
		FATAL_ERROR
		"Could not find zlib headers.\n"
		"You may need to install a package named zlib1g-dev or similarly."
	)
ENDIF(NOT ZLIB_INCLUDE_DIR)

FIND_LIBRARY(
	ZLIB_LIBRARY NAMES z libz.lib
	PATHS /usr/local/lib /usr/lib ${zlib_dirs}
	DOC "Path to zlib library."
)
INCLUDE_DIRECTORIES("${ZLIB_INCLUDE_DIR}")

FIND_PATH(
	PNG_INCLUDE_DIR png.h
	PATHS /usr/local/include /usr/include ${png_dirs}
	DOC "Path to libpng headers."
)
IF(NOT PNG_INCLUDE_DIR)
	MESSAGE(
		FATAL_ERROR
		"Could not find libpng headers.\n"
		"You may need to install a package named libpng12-dev or similarly."
	)
ENDIF(NOT PNG_INCLUDE_DIR)

FIND_LIBRARY(
	PNG_LIBRARY NAMES png libpng.lib
	PATHS /usr/local/lib /usr/lib ${png_dirs}
	DOC "PAth to png library."
)
INCLUDE_DIRECTORIES("${PNG_INCLUDE_DIR}")

FIND_PATH(
	TIFF_INCLUDE_DIR tiff.h
	PATHS /usr/local/include /usr/include ${tiff_dirs}
	PATH_SUFFIXES libtiff
	DOC "Path to libtiff headers."
)
IF(NOT TIFF_INCLUDE_DIR)
	MESSAGE(
		FATAL_ERROR
		"Could not find libtiff headers.\n"
		"You may need to install a package named libtiff4-dev or similarly."
	)
ENDIF(NOT TIFF_INCLUDE_DIR)

FIND_LIBRARY(
	TIFF_LIBRARY tiff libtiff.lib
	PATHS /usr/local/lib /usr/lib ${tiff_dirs}
	PATH_SUFFIXES libtiff
	DOC "Path to tiff library."
)
INCLUDE_DIRECTORIES("${TIFF_INCLUDE_DIR}")

IF(WIN32)
	FIND_PATH(
		BOOST_ROOT boost-build.jam PATHS ${boost_dirs}
		DOC "Path to top-level Boost source directory."
	)
	SET(Boost_USE_STATIC_LIBS ON)
ELSE(WIN32)
	ADD_DEFINITIONS(-DBOOST_TEST_DYN_LINK)
ENDIF(WIN32)

SET(Boost_USE_MULTITHREADED ON)
FIND_PACKAGE(Boost 1.35.0 COMPONENTS unit_test_framework prg_exec_monitor)
IF(NOT Boost_FOUND)
	MESSAGE(
		FATAL_ERROR
		"Could not find boost headers or libraries.\n"
		"You may need to install a package named libboost1.35-dev or similarly."
	)
ENDIF(NOT Boost_FOUND)

INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})

IF(UNIX)
	# We need to manually use XRender.
	FIND_PATH(
		X11_INCLUDE_PATH extensions/Xrender.h
		PATHS /usr/local /usr
		PATH_SUFFIXES include/X11 X11/include
		DOC "The path to extensions/Xrender.h."
	)
	IF (NOT X11_INCLUDE_PATH)
		MESSAGE(
			FATAL_ERROR
			"Could not find Xrender.h\n"
			"You may need to install a package called\n"
			"libxrender-dev or libXrender-dev or similarly."
		)
	ENDIF(NOT X11_INCLUDE_PATH)

	INCLUDE_DIRECTORIES("${X11_INCLUDE_PATH}")

	FindPthreads()
	IF(PTHREADS_FOUND)
		ADD_DEFINITIONS(${PTHREADS_CFLAGS})
		LINK_LIBRARIES(${PTHREADS_LIBS})
	ELSE(PTHREADS_FOUND)
		MESSAGE(
			FATAL_ERROR
			"Could not detect threading flags.\n"
			"Try specifying them manually in PTHREADS_CFLAGS and PTHREADS_LIBS."
		)
	ENDIF(PTHREADS_FOUND)
ELSEIF(MINGW)
	ADD_DEFINITIONS(-mthreads)
	LINK_LIBRARIES(-mthreads)
ELSEIF(WIN32)
	ADD_DEFINITIONS(-DNOMINMAX)
ENDIF(UNIX)

CHECK_INCLUDE_FILE(stdint.h HAVE_STDINT_H)
IF(NOT HAVE_STDINT_H)
	CONFIGURE_FILE(compat/pstdint.h "${CMAKE_CURRENT_BINARY_DIR}/stdint.h" COPYONLY)
	INCLUDE_DIRECTORIES("${CMAKE_CURRENT_BINARY_DIR}")
ELSE(NOT HAVE_STDINT_H)
	FILE(REMOVE "${CMAKE_CURRENT_BINARY_DIR}/stdint.h")
ENDIF(NOT HAVE_STDINT_H)

ADD_DEFINITIONS(
	${QT_DEFINITIONS} -DBOOST_MULTI_INDEX_DISABLE_SERIALIZATION
)

IF(WIN32)
	ADD_DEFINITIONS(-DLIBTIFF_STATIC)
ENDIF(WIN32)

INCLUDE_DIRECTORIES(. foundation interaction zones ${QT_INCLUDES})
LINK_DIRECTORIES(${QT_LIBRARY_DIR})

SET(EXTRA_LIBS)
IF(WIN32)
	FIND_LIBRARY(QJPEG_RELEASE qjpeg PATHS "${QT_PLUGINS_DIR}/imageformats")
	FIND_LIBRARY(QJPEG_DEBUG qjpegd PATHS "${QT_PLUGINS_DIR}/imageformats")
	MARK_AS_ADVANCED(FORCE QJPEG_RELEASE QJPEG_DEBUG)
	IF(QJPEG_RELEASE AND NOT QJPEG_DEBUG)
		SET(QJPEG_DEBUG "${QJPEG_RELEASE}")
	ELSEIF(QJPEG_DEBUG AND NOT QJPEG_RELEASE)
		SET(QJPEG_RELEASE "${QJPEG_DEBUG}")
	ENDIF(QJPEG_RELEASE AND NOT QJPEG_DEBUG)
	LIST(
		APPEND EXTRA_LIBS
		"${QT_QTMAIN_LIBRARY}" optimized "${QJPEG_RELEASE}"
		debug "${QJPEG_DEBUG}"
		winmm imm32 ws2_32 ole32 oleaut32 uuid gdi32 comdlg32 winspool
	)
ENDIF(WIN32)
# ${JPEG_LIBRARY} must go after qjpeg plugin, because otherwise the GNU linker
# won't resolve symbols qjpeg needs from it.
LIST(APPEND EXTRA_LIBS ${TIFF_LIBRARY} ${PNG_LIBRARY} ${ZLIB_LIBRARY} ${JPEG_LIBRARY})

IF(ENABLE_OPENGL)
	LIST(APPEND EXTRA_LIBS ${QT_QTOPENGL_LIBRARY} ${OPENGL_LIBRARIES})
ENDIF()

# Crash reporter, only Windows + MSVC supported for now.
# Must go before generating config.h, as ENABLE_CRASH_REPORTER
# goes in there.
IF(MSVC)
	OPTION(ENABLE_CRASH_REPORTER "Enable crash reporter (only for official builds)" OFF)
ENDIF(MSVC)

OPTION(ENABLE_DEWARPING "Enable experimental dewarping support" OFF)

# Prepare config.h
IF(WIN32)
	SET(TRANSLATIONS_DIR_REL "translations")
ELSE(WIN32)
	SET(TRANSLATIONS_DIR_REL "share/scantailor/translations")
ENDIF(WIN32)
SET(TRANSLATIONS_DIR_ABS "${CMAKE_INSTALL_PREFIX}/${TRANSLATIONS_DIR_REL}")

CONFIGURE_FILE(config.h.in ${CMAKE_BINARY_DIR}/config.h @ONLY)

# crash_reporter is included unconditionally to collect translation sources from there.
ADD_SUBDIRECTORY(crash_reporter)
ADD_SUBDIRECTORY(foundation)
ADD_SUBDIRECTORY(imageproc)
ADD_SUBDIRECTORY(interaction)
ADD_SUBDIRECTORY(zones)
ADD_SUBDIRECTORY(tests)

FILE(GLOB ui_files "ui/*.ui")
SOURCE_GROUP("UI Files" FILES ${ui_files})
QT4_WRAP_UI(ui_sources ${ui_files})
SET_SOURCE_FILES_PROPERTIES(${ui_sources} PROPERTIES GENERATED TRUE)
ADD_SUBDIRECTORY(ui)
INCLUDE_DIRECTORIES("${CMAKE_CURRENT_BINARY_DIR}") # for ui files

ADD_CUSTOM_TARGET(toplevel_ui_sources DEPENDS ${ui_sources})

ADD_SUBDIRECTORY(filters/fix_orientation)
ADD_SUBDIRECTORY(filters/page_split)
ADD_SUBDIRECTORY(filters/deskew)
ADD_SUBDIRECTORY(filters/select_content)
ADD_SUBDIRECTORY(filters/page_layout)
ADD_SUBDIRECTORY(filters/output)

SET(resource_sources)
QT4_ADD_RESOURCES(resource_sources resources/resources.qrc)
SOURCE_GROUP("Generated" FILES ${ui_sources} ${resource_sources})
SOURCE_GROUP("Resources" FILES resources/resources.qrc resources/icons/COPYING)
IF(WIN32)
	SOURCE_GROUP("Resources" FILES resources/win32/resources.rc)
ENDIF()

SET(
	sources
	main.cpp Application.cpp Application.h
	BackgroundExecutor.cpp BackgroundExecutor.h
	OpenGLSupport.cpp OpenGLSupport.h
	PixmapRenderer.cpp PixmapRenderer.h
	SkinnedButton.cpp SkinnedButton.h
	BubbleAnimation.cpp BubbleAnimation.h
	ProcessingIndicationWidget.cpp ProcessingIndicationWidget.h
	Dpi.cpp Dpi.h Dpm.cpp Dpm.h
	SmartFilenameOrdering.cpp SmartFilenameOrdering.h
	ImageInfo.cpp ImageInfo.h
	ImageFileInfo.cpp ImageFileInfo.h
	ImageMetadata.cpp ImageMetadata.h
	RecentProjects.cpp RecentProjects.h
	SettingsDialog.cpp SettingsDialog.h
	FixDpiDialog.cpp FixDpiDialog.h
	FixDpiSinglePageDialog.cpp FixDpiSinglePageDialog.h
	ProjectCreationContext.cpp ProjectCreationContext.h
	ProjectOpeningContext.cpp ProjectOpeningContext.h
	MainWindow.cpp MainWindow.h
	PageSelectionAccessor.cpp PageSelectionAccessor.h
	ContentSpanFinder.cpp ContentSpanFinder.h
	PhysicalTransformation.cpp PhysicalTransformation.h
	ImageTransformation.cpp ImageTransformation.h
	ImagePixmapUnion.h
	ImageViewBase.cpp ImageViewBase.h
	BasicImageView.cpp BasicImageView.h
	StageListView.cpp StageListView.h
	ThumbnailLoadResult.h
	ThumbnailPixmapCache.cpp ThumbnailPixmapCache.h
	ThumbnailBase.cpp ThumbnailBase.h
	ThumbnailSequence.cpp ThumbnailSequence.h
	ThumbnailFactory.cpp ThumbnailFactory.h
	IncompleteThumbnail.cpp IncompleteThumbnail.h
	ContentBoxPropagator.cpp ContentBoxPropagator.h
	PageOrientationPropagator.cpp PageOrientationPropagator.h
	DebugImages.cpp DebugImages.h
	DebugImageView.cpp DebugImageView.h
	TabbedDebugImages.cpp TabbedDebugImages.h
	ImageId.cpp ImageId.h
	PageId.cpp PageId.h
	PageInfo.cpp PageInfo.h
	BackgroundTask.cpp BackgroundTask.h
	ProcessingTaskQueue.cpp ProcessingTaskQueue.h
	PageSequence.cpp PageSequence.h
	ProjectPages.cpp ProjectPages.h
	StageSequence.cpp StageSequence.h
	FilterData.cpp FilterData.h
	ImageMetadataLoader.cpp ImageMetadataLoader.h
	TiffReader.cpp TiffReader.h
	TiffWriter.cpp TiffWriter.h
	PngMetadataLoader.cpp PngMetadataLoader.h

=== crash_reporter/CMakeLists.txt ===
PROJECT(CrashReporter)

ADD_DEFINITIONS(-D_UNICODE)
INCLUDE_DIRECTORIES(google-breakpad)

MACRO(LIST_ITEMS_PREPEND LIST PREFIX)
	SET(tmp_list_)
	FOREACH(item ${${LIST}})
		LIST(APPEND tmp_list_ "${PREFIX}${item}")
	ENDFOREACH(item)
	SET(${LIST} ${tmp_list_})
ENDMACRO(LIST_ITEMS_PREPEND)

SET(eh_sources exception_handler.cc exception_handler.h)
LIST_ITEMS_PREPEND(eh_sources google-breakpad/client/windows/handler/)

SET(cg_sources crash_generation_client.cc crash_generation_client.h)
LIST_ITEMS_PREPEND(cg_sources google-breakpad/client/windows/crash_generation/)

SET(common_sources guid_string.cc guid_string.h)
LIST_ITEMS_PREPEND(common_sources google-breakpad/common/windows/)

IF(ENABLE_CRASH_REPORTER)
	ADD_LIBRARY(crash_handler ${eh_sources} ${cg_sources} ${common_sources})
ENDIF(ENABLE_CRASH_REPORTER)

SET(
	crash_reporter_sources
	main.cpp CrashReportDialog.cpp CrashReportDialog.h
	MultipartFormData.cpp MultipartFormData.h
)
SOURCE_GROUP("Sources" FILES ${crash_reporter_sources})
QT4_AUTOMOC(${crash_reporter_sources})

FILE(GLOB ui_files "ui/*.ui")
SOURCE_GROUP("Ui Files" FILES ${ui_files})
QT4_WRAP_UI(ui_sources ${ui_files})
SET_SOURCE_FILES_PROPERTIES(${ui_sources} PROPERTIES GENERATED TRUE)
ADD_SUBDIRECTORY(ui)
INCLUDE_DIRECTORIES("${CMAKE_CURRENT_BINARY_DIR}") # for ui files

IF(ENABLE_CRASH_REPORTER)
	ADD_EXECUTABLE(CrashReporter WIN32 ${crash_reporter_sources} ${ui_sources})

	TARGET_LINK_LIBRARIES(
		CrashReporter ${QT_QTGUI_LIBRARY} ${QT_QTXML_LIBRARY} ${QT_QTNETWORK_LIBRARY}
		${QT_QTXML_LIBRARY} ${QT_QTCORE_LIBRARY} ${QT_QTMAIN_LIBRARY} ${PNG_LIBRARY}
		winmm imm32 ws2_32
	)
ENDIF(ENABLE_CRASH_REPORTER)

TRANSLATION_SOURCES(crashreporter ${crash_reporter_sources} ${ui_files})

=== foundation/CMakeLists.txt ===
PROJECT("Foundation library")

INCLUDE_DIRECTORIES("${CMAKE_CURRENT_BINARY_DIR}")

SET(
	sources
	NonCopyable.h IntrusivePtr.h RefCountable.h
	AlignedArray.h
	SafeDeletingQObjectPtr.h
	ScopedIncDec.h ScopedDecInc.h
	Span.h VirtualFunction.h FlagOps.h
	AutoRemovingFile.cpp AutoRemovingFile.h
	Proximity.cpp Proximity.h
	Property.h
	PropertyFactory.cpp PropertyFactory.h
	PropertySet.cpp PropertySet.h
	PerformanceTimer.cpp PerformanceTimer.h
	QtSignalForwarder.cpp QtSignalForwarder.h
)
SOURCE_GROUP("Sources" FILES ${sources})
QT4_AUTOMOC(${sources})

ADD_LIBRARY(foundation STATIC ${sources})

=== filters/deskew/CMakeLists.txt ===
PROJECT("Deskew Filter")

INCLUDE_DIRECTORIES(BEFORE "${CMAKE_CURRENT_BINARY_DIR}")

FILE(GLOB ui_files "ui/*.ui")
QT4_WRAP_UI(ui_sources ${ui_files})
SET_SOURCE_FILES_PROPERTIES(${ui_sources} PROPERTIES GENERATED TRUE)
SOURCE_GROUP("UI Files" FILES ${ui_files})
SOURCE_GROUP("Generated" FILES ${ui_sources})

SET(
	sources
	ImageView.cpp ImageView.h
	Thumbnail.cpp Thumbnail.h
	Filter.cpp Filter.h
	OptionsWidget.cpp OptionsWidget.h
	Settings.cpp Settings.h
	Task.cpp Task.h
	CacheDrivenTask.cpp CacheDrivenTask.h
	Dependencies.cpp Dependencies.h
	Params.cpp Params.h
)
SOURCE_GROUP("Sources" FILES ${sources})
QT4_AUTOMOC(${sources})

ADD_LIBRARY(deskew STATIC ${sources} ${ui_sources})

TRANSLATION_SOURCES(scantailor ${sources} ${ui_files})

=== filters/output/CMakeLists.txt ===
PROJECT("Output Filter")

INCLUDE_DIRECTORIES(BEFORE "${CMAKE_CURRENT_BINARY_DIR}")

FILE(GLOB ui_files "ui/*.ui")
QT4_WRAP_UI(ui_sources ${ui_files})
SET_SOURCE_FILES_PROPERTIES(${ui_sources} PROPERTIES GENERATED TRUE)
SOURCE_GROUP("UI Files" FILES ${ui_files})
SOURCE_GROUP("Generated" FILES ${ui_sources})

SET(
	sources
	ApplyColorsDialog.cpp ApplyColorsDialog.h
	ChangeDpiDialog.cpp ChangeDpiDialog.h
	ImageView.cpp ImageView.h
	ImageViewTab.h
	TabbedImageView.cpp TabbedImageView.h
	Filter.cpp Filter.h
	OptionsWidget.cpp OptionsWidget.h
	Task.cpp Task.h
	CacheDrivenTask.cpp CacheDrivenTask.h
	OutputGenerator.cpp OutputGenerator.h
	Settings.cpp Settings.h
	Thumbnail.cpp Thumbnail.h
	Utils.cpp Utils.h
	Params.cpp Params.h
	BlackWhiteOptions.cpp BlackWhiteOptions.h
	ColorGrayscaleOptions.cpp ColorGrayscaleOptions.h
	RenderParams.cpp RenderParams.h
	ColorParams.cpp ColorParams.h
	OutputImageParams.cpp OutputImageParams.h
	OutputFileParams.cpp OutputFileParams.h
	OutputParams.cpp OutputParams.h
	PictureLayerProperty.cpp PictureLayerProperty.h
	PictureZonePropFactory.cpp PictureZonePropFactory.h
	PictureZonePropDialog.cpp PictureZonePropDialog.h
	PictureZoneComparator.cpp PictureZoneComparator.h
	PictureZoneEditor.cpp PictureZoneEditor.h
	FillColorProperty.cpp FillColorProperty.h
	FillZonePropFactory.cpp FillZonePropFactory.h
	FillZoneComparator.cpp FillZoneComparator.h
	FillZoneEditor.cpp FillZoneEditor.h
	ColorPickupInteraction.cpp ColorPickupInteraction.h
	DespeckleState.cpp DespeckleState.h
	DespeckleView.cpp DespeckleView.h
	DespeckleVisualization.cpp DespeckleVisualization.h
	DespeckleLevel.cpp DespeckleLevel.h
)
SOURCE_GROUP("Sources" FILES ${sources})
QT4_AUTOMOC(${sources})

ADD_LIBRARY(output STATIC ${sources} ${ui_sources})
ADD_DEPENDENCIES(output toplevel_ui_sources)

TRANSLATION_SOURCES(scantailor ${sources} ${ui_files})

=== imageproc/tests/CMakeLists.txt ===
INCLUDE_DIRECTORIES(BEFORE ..)

SET(
	sources
	main.cpp
	TestBinaryImage.cpp TestReduceThreshold.cpp
	TestSlicedHistogram.cpp
	TestConnCompEraser.cpp TestConnCompEraserExt.cpp
	TestGrayscale.cpp
	TestRasterOp.cpp TestShear.cpp
	TestOrthogonalRotation.cpp
	TestSkewFinder.cpp
	TestScale.cpp
	TestTransform.cpp
	TestMorphology.cpp
	TestDentFinder.cpp
	TestBinarize.cpp
	TestPolygonRasterizer.cpp
	TestKFill.cpp
	TestSeedFill.cpp
	TestSEDM.cpp
	TestLU.cpp
	TestLM.cpp
	Utils.cpp Utils.h
)
SOURCE_GROUP("Sources" FILES ${sources})

SET(
	libs
	imageproc ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
	${Boost_PRG_EXECUTION_MONITOR_LIBRARY}
	${QT_QTGUI_LIBRARY} ${QT_QTCORE_LIBRARY} ${EXTRA_LIBS}
)

ADD_EXECUTABLE(imageproc_tests ${sources})
TARGET_LINK_LIBRARIES(imageproc_tests ${libs})

=== packaging/windows/patch_libtiff/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0)

PROJECT(patch_libtiff)

GET_FILENAME_COMPONENT(outer_dir "${PROJECT_SOURCE_DIR}/../../../.." ABSOLUTE)

FILE(GLOB tiff_dirs "${outer_dir}/tiff-[0-9]*.[0-9]*.[0-9]*")
FIND_PATH(
	TIFF_DIR libtiff/tiff.h PATHS ${tiff_dirs}
	DOC "Path to top-level tiff source directory."
)

IF(NOT DEBIAN_LIBTIFF_PATCH)
	FILE(GLOB tiff_patches "${outer_dir}/tiff*.diff")
	IF(tiff_patches)
		LIST(GET tiff_patches 0 tiff_patch)
		SET(
			DEBIAN_LIBTIFF_PATCH "${tiff_patch}" CACHE FILEPATH
			"Path to the uncompressed .diff file" FORCE
		)
	ENDIF(tiff_patches)
ENDIF(NOT DEBIAN_LIBTIFF_PATCH)

FIND_PROGRAM(
	PATCH_EXE patch
	PATHS "[HKEY_LOCAL_MACHINE\\SOFTWARE\\GnuWin32;InstallPath]/bin"
	DOC "Full path to patch.exe"
)

IF(NOT TIFF_DIR)
	MESSAGE(FATAL_ERROR "TIFF source directory not found. You may specify it manually.")
ELSEIF(NOT DEBIAN_LIBTIFF_PATCH)
	MESSAGE(FATAL_ERROR "The uncompressed Debian patch file for libtiff wasn't found.")
ELSEIF(NOT PATCH_EXE)
	MESSAGE(FATAL_ERROR "The patch utility wasn't found.")
ENDIF(NOT TIFF_DIR)

CONFIGURE_FILE(
	apply_individual_patches.cmake.in
	"${CMAKE_BINARY_DIR}/apply_individual_patches.cmake" @ONLY
)

ADD_CUSTOM_TARGET(
	apply_patches ALL
	COMMAND "${PATCH_EXE}" -p1 --binary -i "${DEBIAN_LIBTIFF_PATCH}"
	COMMAND "${CMAKE_COMMAND}" -P
	"${CMAKE_BINARY_DIR}/apply_individual_patches.cmake"
	WORKING_DIRECTORY "${TIFF_DIR}"
)

=== debian/changelog ===
scantailor (0.9.9-0ubuntu1) maverick; urgency=low

  * New upstream release.
  * Update debian/copyright.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Mon, 28 Jun 2010 11:09:40 +0200

scantailor (0.9.8.1-0ubuntu1) maverick; urgency=low

  * New upstream release.
  * Bump Standards.
  * Switch to 3.0 (quilt) format.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Wed, 12 May 2010 13:25:01 +0200

scantailor (0.9.7.2-0ubuntu1) lucid; urgency=low

  * New upstream release.
  * Update debian/copyright.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Sat, 06 Feb 2010 01:48:24 +0100

scantailor (0.9.7-0ubuntu3) lucid; urgency=low

  * Try again, this time correctly specifying the desired build architectures

 -- Scott Kitterman <scott@kitterman.com>  Fri, 15 Jan 2010 00:23:08 -0500

scantailor (0.9.7-0ubuntu2) lucid; urgency=low

  * Bump boost build-depends to libboost-test1.40-dev
  * Build for Architecture: amd64 i386 ia64 powerpc sparc (not armel) due to
    arm processor limitations
    - selected processor does not support `swp r0,r3,[r2]

 -- Scott Kitterman <scott@kitterman.com>  Thu, 14 Jan 2010 21:32:03 -0500

scantailor (0.9.7-0ubuntu1) lucid; urgency=low

  * New upstream release:
    - It's now possible to manually edit picture zones that weren't
      properly auto-detected.
    - A crash that supposedly only affected the Windows version was fixed.
    - Book spine detection was improved.
    - The central area now has scrollbars.
    - Page dragging can now also be done with a middle mouse button in
      addition to the left one.
    - Experimental and optional OpenGL support to accelerate drawing
      operations.
    - Bulgarian translation was added.
  * debian/control:
    - Bump Standards.
    - Build-depend on libxrender-dev.
    - Lines should not be longer than 80 chars.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Wed, 11 Nov 2009 01:30:19 +0100

scantailor (0.9.6-0ubuntu1) karmic; urgency=low

  * Initial release (LP: #370254).

 -- Артём Попов <artfwo@gmail.com>  Thu, 06 Aug 2009 17:57:26 +0700

=== debian/control ===
Source: scantailor
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Артём Попов <artfwo@gmail.com>
Build-Depends: cdbs, debhelper (>= 5), cmake (>= 2.6.0),
 libqt4-dev (>= 4.4.0), libjpeg62-dev, libpng12-dev, libtiff4-dev,
 libboost-test1.40-dev, libxrender-dev
Standards-Version: 3.8.4
Homepage: http://scantailor.sourceforge.net/

Package: scantailor
Architecture: amd64 i386 ia64 powerpc sparc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Interactive post-processing tool for scanned pages
 Scan Tailor is an interactive post-processing tool for scanned pages. It
 performs operations such as page splitting, deskewing, adding/removing
 borders, and others. You give it raw scans, and you get pages ready to be
 printed or assembled into a PDF or DJVU file. Scanning, optical character
 recognition, and assembling multi-page documents are out of scope of this
 project.

## scantailor 0.9.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -266,7 +266,7 @@
 	ADD_DEFINITIONS(-DLIBTIFF_STATIC)
 ENDIF(WIN32)
 
-INCLUDE_DIRECTORIES(. foundation interaction zones ${QT_INCLUDES})
+INCLUDE_DIRECTORIES(. foundation math interaction zones ${QT_INCLUDES})
 LINK_DIRECTORIES(${QT_LIBRARY_DIR})
 
 SET(EXTRA_LIBS)
@@ -316,6 +316,7 @@
 # crash_reporter is included unconditionally to collect translation sources from there.
 ADD_SUBDIRECTORY(crash_reporter)
 ADD_SUBDIRECTORY(foundation)
+ADD_SUBDIRECTORY(math)
 ADD_SUBDIRECTORY(imageproc)
 ADD_SUBDIRECTORY(interaction)
 ADD_SUBDIRECTORY(zones)

=== foundation/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,8 @@
 	sources
 	NonCopyable.h IntrusivePtr.h RefCountable.h
 	AlignedArray.h
+	NumericTraits.h
+	FastQueue.h
 	SafeDeletingQObjectPtr.h
 	ScopedIncDec.h ScopedDecInc.h
 	Span.h VirtualFunction.h FlagOps.h
@@ -16,6 +18,7 @@
 	PropertySet.cpp PropertySet.h
 	PerformanceTimer.cpp PerformanceTimer.h
 	QtSignalForwarder.cpp QtSignalForwarder.h
+	VecNT.h
 )
 SOURCE_GROUP("Sources" FILES ${sources})
 QT4_AUTOMOC(${sources})

=== imageproc/CMakeLists.txt ===
PROJECT(imageproc)

SET(
	sources
	Constants.h Constants.cpp
	BinaryImage.cpp BinaryImage.h
	BinaryThreshold.cpp BinaryThreshold.h
	SlicedHistogram.cpp SlicedHistogram.h
	ByteOrder.h BWColor.h
	ConnComp.h Connectivity.h
	BitOps.cpp BitOps.h
	SeedFill.cpp SeedFill.h
	kFill.cpp kFill.h
	ConnCompEraser.cpp ConnCompEraser.h
	ConnCompEraserExt.cpp ConnCompEraserExt.h
	GrayImage.cpp GrayImage.h
	Grayscale.cpp Grayscale.h
	RasterOp.h GrayRasterOp.h RasterOpGeneric.h
	UpscaleIntegerTimes.cpp UpscaleIntegerTimes.h
	ReduceThreshold.cpp ReduceThreshold.h
	Shear.cpp Shear.h
	SkewFinder.cpp SkewFinder.h
	OrthogonalRotation.cpp OrthogonalRotation.h
	Scale.cpp Scale.h
	Transform.cpp Transform.h
	Morphology.cpp Morphology.h
	DentFinder.cpp DentFinder.h
	IntegralImage.h
	Binarize.cpp Binarize.h
	PolygonUtils.cpp PolygonUtils.h
	PolygonRasterizer.cpp PolygonRasterizer.h
	HoughLineDetector.cpp HoughLineDetector.h
	GaussBlur.cpp GaussBlur.h
	MorphGradientDetect.cpp MorphGradientDetect.h
	LeastSquaresFit.cpp LeastSquaresFit.h
	PolynomialLine.cpp PolynomialLine.h
	PolynomialSurface.cpp PolynomialSurface.h
	SavGolKernel.cpp SavGolKernel.h
	SavGolFilter.cpp SavGolFilter.h
	DrawOver.cpp DrawOver.h
	AdjustBrightness.cpp AdjustBrightness.h
	SEDM.cpp SEDM.h
	ConnectivityMap.cpp ConnectivityMap.h
	InfluenceMap.cpp InfluenceMap.h
	MaxWhitespaceFinder.cpp MaxWhitespaceFinder.h
	ColorInterpolation.cpp ColorInterpolation.h
	LU.cpp LU.h
	LM.cpp LM.h
	LocalMinMaxGeneric.h
	SeedFillGeneric.cpp SeedFillGeneric.h
	FindPeaksGeneric.h
)

SOURCE_GROUP(Sources FILES ${sources})

ADD_LIBRARY(imageproc STATIC ${sources})

ADD_SUBDIRECTORY(tests)

=== interaction/CMakeLists.txt ===
PROJECT(interaction)

INCLUDE_DIRECTORIES("${CMAKE_CURRENT_BINARY_DIR}")

SET(
	sources
	DraggableObject.h
	DraggablePoint.cpp DraggablePoint.h
	DraggableLineSegment.cpp DraggableLineSegment.h
	ObjectDragHandler.cpp ObjectDragHandler.h
	InteractionHandler.cpp InteractionHandler.h
	InteractionState.cpp InteractionState.h
	DragHandler.cpp DragHandler.h
	DragWatcher.cpp DragWatcher.h
	ZoomHandler.cpp ZoomHandler.h
)

SOURCE_GROUP(Sources FILES ${sources})
QT4_AUTOMOC(${sources})

ADD_LIBRARY(interaction STATIC ${sources})

TRANSLATION_SOURCES(scantailor ${sources})

=== math/CMakeLists.txt ===
PROJECT("Math library")

INCLUDE_DIRECTORIES("${CMAKE_CURRENT_BINARY_DIR}")

SET(
	sources
	ToLineProjector.cpp ToLineProjector.h
)
SOURCE_GROUP("Sources" FILES ${sources})

ADD_LIBRARY(math STATIC ${sources})

=== filters/output/CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,7 @@
 	Task.cpp Task.h
 	CacheDrivenTask.cpp CacheDrivenTask.h
 	OutputGenerator.cpp OutputGenerator.h
+	OutputMargins.h
 	Settings.cpp Settings.h
 	Thumbnail.cpp Thumbnail.h
 	Utils.cpp Utils.h

=== filters/page_split/CMakeLists.txt ===
PROJECT("Page Split Filter")

INCLUDE_DIRECTORIES(BEFORE "${CMAKE_CURRENT_BINARY_DIR}")

FILE(GLOB ui_files "ui/*.ui")
QT4_WRAP_UI(ui_sources ${ui_files})
SET_SOURCE_FILES_PROPERTIES(${ui_sources} PROPERTIES GENERATED TRUE)
SOURCE_GROUP("UI Files" FILES ${ui_files})
SOURCE_GROUP("Generated" FILES ${ui_sources})

SET(
	sources
	SplitLineObject.h
	ImageView.cpp ImageView.h
	Thumbnail.cpp Thumbnail.h
	Params.cpp Params.h
	Dependencies.cpp Dependencies.h
	PageLayout.cpp PageLayout.h
	PageLayoutEstimator.cpp PageLayoutEstimator.h
	VertLineFinder.cpp VertLineFinder.h
	Filter.cpp Filter.h
	OptionsWidget.cpp OptionsWidget.h
	SplitModeDialog.cpp SplitModeDialog.h
	Settings.cpp Settings.h
	Task.cpp Task.h
	CacheDrivenTask.cpp CacheDrivenTask.h
	LayoutType.cpp LayoutType.h
	UnremoveButton.cpp UnremoveButton.h
)
SOURCE_GROUP("Sources" FILES ${sources})
QT4_AUTOMOC(${sources})

ADD_LIBRARY(page_split STATIC ${sources} ${ui_sources})

TRANSLATION_SOURCES(scantailor ${sources} ${ui_files})

=== filters/select_content/CMakeLists.txt ===
PROJECT("Select Content Filter")

INCLUDE_DIRECTORIES(BEFORE "${CMAKE_CURRENT_BINARY_DIR}")

FILE(GLOB ui_files "ui/*.ui")
QT4_WRAP_UI(ui_sources ${ui_files})
SET_SOURCE_FILES_PROPERTIES(${ui_sources} PROPERTIES GENERATED TRUE)
SOURCE_GROUP("UI Files" FILES ${ui_files})
SOURCE_GROUP("Generated" FILES ${ui_sources})

SET(
	sources
	ImageView.cpp ImageView.h
	Filter.cpp Filter.h
	OptionsWidget.cpp OptionsWidget.h
	ContentBoxFinder.cpp ContentBoxFinder.h
	Task.cpp Task.h
	CacheDrivenTask.cpp CacheDrivenTask.h
	Dependencies.cpp Dependencies.h
	Params.cpp Params.h
	Settings.cpp Settings.h
	Thumbnail.cpp Thumbnail.h
	PhysSizeCalc.cpp PhysSizeCalc.h
	OrderByWidthProvider.cpp OrderByWidthProvider.h
	OrderByHeightProvider.cpp OrderByHeightProvider.h
)
SOURCE_GROUP("Sources" FILES ${sources})
QT4_AUTOMOC(${sources})

ADD_LIBRARY(select_content STATIC ${sources} ${ui_sources})

TRANSLATION_SOURCES(scantailor ${sources} ${ui_files})

=== imageproc/tests/CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
 
 SET(
 	libs
-	imageproc ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
+	imageproc math foundation ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}
 	${Boost_PRG_EXECUTION_MONITOR_LIBRARY}
 	${QT_QTGUI_LIBRARY} ${QT_QTCORE_LIBRARY} ${EXTRA_LIBS}
 )

=== packaging/windows/CMakeLists.txt ===
FIND_PROGRAM(
	MAKENSIS_EXE makensis
	PATHS "[HKEY_LOCAL_MACHINE\\Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\NSIS;InstallLocation]"
)
IF(NOT MAKENSIS_EXE)
	MESSAGE(
		FATAL_ERROR
		"makensis.exe could not be found.\n"
		"makensis.exe is a part of NSIS. Get NSIS from http://nsis.sf.net/"
	)
ENDIF(NOT MAKENSIS_EXE)

IF(MINGW)
	FIND_FILE(
		MINGWM10_DLL mingwm10.dll
		PATHS c:/MinGW/bin ENV PATH
		DOC "Full path to mingwm10.dll"
	)
	IF(NOT MINGWM10_DLL)
		MESSAGE(
			FATAL_ERROR
			"Could not find mingwm10.dll\n"
			"It should be in the 'bin' subdirectory of your MinGW installation."
		)
	ENDIF(NOT MINGWM10_DLL)
	TO_NATIVE_PATH("${MINGWM10_DLL}" MINGWM10_DLL)
ELSEIF(MSVC)
	GET_FILENAME_COMPONENT(make_program_dir "${CMAKE_MAKE_PROGRAM}" PATH)
	FIND_FILE(
		VC_REDIST_DIR VC/redist PATHS "${make_program_dir}"
		PATH_SUFFIXES .. ../.. DOC "VC/redist directory."
	)
	IF(VC_REDIST_DIR)
		# Get rid of .. components in the path.
		GET_FILENAME_COMPONENT(VC_REDIST_DIR "${VC_REDIST_DIR}" ABSOLUTE)
		SET(VC_REDIST_DIR "${VC_REDIST_DIR}" CACHE PATH "VC/redist directory." FORCE)

		# Find CRT redistributables.
		FILE(GLOB crt_redist_dirs "${VC_REDIST_DIR}/x86/Microsoft.VC*.CRT")
		IF(crt_redist_dirs)
			LIST(GET crt_redist_dirs 0 CRT_REDIST_PATH)
			GET_FILENAME_COMPONENT(CRT_REDIST_DIR "${CRT_REDIST_PATH}" NAME)
		ENDIF(crt_redist_dirs)
	ENDIF(VC_REDIST_DIR)

	IF (NOT CRT_REDIST_PATH)
		MESSAGE(
			FATAL_ERROR
			"Could not find Visual Studio redistributables.\n"
			"They are typically located in a directory like:\n"
			"C:\Program Files\Microsoft Visual Studio 9.0\VC\redist\n"
			"Please set VC_REDIST_DIR accordinally.\n"
			"Specifically, we are after redist\x86\Microsoft.VC*.CRT"
		)
	ENDIF(NOT CRT_REDIST_PATH)

	TO_NATIVE_PATH("${CRT_REDIST_PATH}" CRT_REDIST_PATH)
	TO_NATIVE_PATH("${CRT_REDIST_DIR}" CRT_REDIST_DIR)
ENDIF(MINGW)

SET(LICENSE_FILE "${CMAKE_SOURCE_DIR}/GPL3.txt")
SET(INSTALLER_FILENAME "scantailor-${VERSION}-install.exe")

SET(REGISTER_EXTENSION_NSH "${CMAKE_CURRENT_SOURCE_DIR}/registerExtension.nsh")
TO_NATIVE_PATH("${REGISTER_EXTENSION_NSH}" REGISTER_EXTENSION_NSH)

CONFIGURE_FILE(scantailor.nsi.in ${CMAKE_BINARY_DIR}/scantailor.nsi @ONLY)

GET_TARGET_PROPERTY(SCANTAILOR_EXE scantailor LOCATION)
TO_NATIVE_PATH("${SCANTAILOR_EXE}" SCANTAILOR_EXE)

SET(extra_deps scantailor compile_translations)

SET(DUMP_SYMBOLS_COMMANDS "")
IF(ENABLE_CRASH_REPORTER)
	GET_TARGET_PROPERTY(CRASHREPORTER_EXE CrashReporter LOCATION)
	TO_NATIVE_PATH("${CRASHREPORTER_EXE}" CRASHREPORTER_EXE)
	LIST(APPEND extra_deps CrashReporter)
	SET(
		DUMP_SYMBOLS_COMMANDS
		COMMAND "${CMAKE_COMMAND}" ARGS -E echo "Dumping symbols..."
		COMMAND "${DUMP_SYMS_EXECUTABLE}" ARGS "${SCANTAILOR_EXE}"
		">" "${SYMBOLS_PATH}/temp.sym"
		COMMAND "${CMAKE_COMMAND}" ARGS "-DSYMBOLS_PATH=${SYMBOLS_PATH}"
		-P "${CMAKE_SOURCE_DIR}/cmake/move_sym_file.cmake"
	)
ENDIF(ENABLE_CRASH_REPORTER)

# SCANTAILOR_EXE and CRASHREPORTER_EXE may contain variable references
# that are only known at run time, so we pass them to makensis, rather
# than harcoding them into scantailor.nsi
ADD_CUSTOM_COMMAND(
	OUTPUT "${INSTALLER_FILENAME}"
	${DUMP_SYMBOLS_COMMANDS}
	COMMAND "${MAKENSIS_EXE}" /V2
	"/DSCANTAILOR_EXE=${SCANTAILOR_EXE}"
	"/DCRASHREPORTER_EXE=${CRASHREPORTER_EXE}" scantailor.nsi
	WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
	MAIN_DEPENDENCY ${CMAKE_BINARY_DIR}/scantailor.nsi
	DEPENDS ${extra_deps}
	VERBATIM
)

OPTION(BUILD_INSTALLER_BY_DEFAULT "Wheter the \"installer\" target gets built by default" ON)
SET(installer_target installer)
IF(BUILD_INSTALLER_BY_DEFAULT)
	LIST(APPEND installer_target ALL)
ENDIF()
LIST(APPEND installer_target DEPENDS "${INSTALLER_FILENAME}")
ADD_CUSTOM_TARGET(${installer_target})

=== packaging/windows/build_deps/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

SET(
	CMAKE_USER_MAKE_RULES_OVERRIDE
	"${CMAKE_SOURCE_DIR}/../../../cmake/default_cflags.cmake"
)
SET(
	CMAKE_USER_MAKE_RULES_OVERRIDE_CXX
	"${CMAKE_SOURCE_DIR}/../../../cmake/default_cxxflags.cmake"
)

PROJECT("Scan Tailor Dependencies")

# This forces Visual Studio 2008 SP1 to actually link to the versions of the
# libraries it ships with!  It's harmless on other platforms.
ADD_DEFINITIONS(-D_BIND_TO_CURRENT_VCLIBS_VERSION=1)

# Qt's -system-libpng, -system-libjpeg, etc are largely broken with regards
# to static libraries, so it expects:
# libpng.lib on MSVC and libpng.lib.a on MinGW.
SET(CMAKE_STATIC_LIBRARY_PREFIX lib)
IF(MINGW)
	SET(CMAKE_STATIC_LIBRARY_SUFFIX .lib.a)
ELSE(MINGW)
	SET(CMAKE_STATIC_LIBRARY_SUFFIX .lib)
ENDIF(MINGW)

INCLUDE(../../../cmake/SetDefaultBuildType.cmake)
INCLUDE(../../../cmake/SetDefaultGccFlags.cmake)
INCLUDE(../../../cmake/ToNativePath.cmake)

ST_SET_DEFAULT_BUILD_TYPE(Release)
ST_SET_DEFAULT_GCC_FLAGS()

GET_FILENAME_COMPONENT(outer_dir "${PROJECT_SOURCE_DIR}/../../../.." ABSOLUTE)

FILE(GLOB jpeg_dirs "${outer_dir}/jpeg-[0-9]*")
FILE(GLOB zlib_dirs "${outer_dir}/zlib-[0-9]*.[0-9]*.[0-9]*")
FILE(GLOB png_dirs "${outer_dir}/libpng-[0-9]*.[0-9]*.[0-9]*")
FILE(GLOB tiff_dirs "${outer_dir}/tiff-[0-9]*.[0-9]*.[0-9]*")
FILE(GLOB qt_dirs "${outer_dir}/qt-win-*-4.[0-9]*")
FILE(GLOB qt_dirs2 "C:/Qt/4.*.*")
FILE(GLOB qt_dirs3 "C:/Qt/20*/qt")
FILE(GLOB boost_dirs "${outer_dir}/boost_1_[0-9]*_[0-9]*")
FILE(GLOB boost_jam_dirs "${outer_dir}/boost-jam-*")

FIND_PATH(
	JPEG_DIR jpeglib.h HINTS ${jpeg_dirs}
	DOC "Path to jpeg source directory."
)
FIND_PATH(
	ZLIB_DIR zlib.h HINTS ${zlib_dirs}
	DOC "Path to zlib source directory."
)
FIND_PATH(
	PNG_DIR png.h HINTS ${png_dirs}
	DOC "Path to libpng source directory."
)
FIND_PATH(
	TIFF_DIR libtiff/tiff.h HINTS ${tiff_dirs}
	DOC "Path to top-level tiff source directory."
)
FIND_PATH(
	QT_DIR projects.pro HINTS ${qt_dirs} ${qt_dirs2} ${qt_dirs3}
	DOC "Path to top-level Qt source directory."
)
FIND_PATH(
	BOOST_DIR boost/foreach.hpp HINTS ${boost_dirs}
	DOC "Path to top-level Boost source directory."
)
FIND_PROGRAM(
	BJAM_EXECUTABLE bjam HINTS ${boost_jam_dirs}
	DOC "Path to a directory containing bjam executable."
)

IF(NOT JPEG_DIR)
	MESSAGE(FATAL_ERROR "JPEG source directory not found. You may specify it manually.")
ELSEIF(NOT ZLIB_DIR)
	MESSAGE(FATAL_ERROR "ZLIB source directory not found. You may specify it manually.")
ELSEIF(NOT PNG_DIR)
	MESSAGE(FATAL_ERROR "LibPNG source directory not found. You may specify it manually.")
ELSEIF(NOT TIFF_DIR)
	MESSAGE(FATAL_ERROR "TIFF source directory not found. You may specify it manually.")
ELSEIF(NOT QT_DIR)
	MESSAGE(FATAL_ERROR "Qt source directory not found. You may specify it manually.")
ELSEIF(NOT BOOST_DIR)
	MESSAGE(FATAL_ERROR "Boost source directory not found. You may specify it manually.")
ELSEIF(NOT BJAM_EXECUTABLE)
	MESSAGE(FATAL_ERROR "bjam executable not found. You may specify it manually.")
ENDIF(NOT JPEG_DIR)

MACRO(LIST_ITEMS_PREPEND LIST PREFIX)
	SET(tmp_list_)
	FOREACH(item ${${LIST}})
		LIST(APPEND tmp_list_ "${PREFIX}${item}")
	ENDFOREACH(item)
	SET(${LIST} ${tmp_list_})
ENDMACRO(LIST_ITEMS_PREPEND)

#=================================== JPEG ===================================#

# Patch jmorecfg.h to prevent double definition of INT32.
IF(NOT EXISTS "${JPEG_DIR}/jmorecfg.h.orig")
	FILE(READ "${JPEG_DIR}/jmorecfg.h" jmorecfg_h_orig)
	STRING(REPLACE "XMD_H" "_BASETSD_H" jmorecfg_h "${jmorecfg_h_orig}")
	FILE(WRITE "${JPEG_DIR}/jmorecfg.h" "${jmorecfg_h}")
	FILE(WRITE "${JPEG_DIR}/jmorecfg.h.orig" "${jmorecfg_h_orig}")
	SET(jmorecfg_h "")
	SET(jmorecfg_h_orig "")
ENDIF(NOT EXISTS "${JPEG_DIR}/jmorecfg.h.orig")

SET(
	libjpeg_sources
	jaricom.c jcapimin.c jcapistd.c jcarith.c jccoefct.c jccolor.c
	jcdctmgr.c jchuff.c jcinit.c jcmainct.c jcmarker.c jcmaster.c
	jcomapi.c jcparam.c jcprepct.c jcsample.c jctrans.c jdapimin.c
	jdapistd.c jdarith.c jdatadst.c jdatasrc.c jdcoefct.c jdcolor.c
	jddctmgr.c jdhuff.c jdinput.c jdmainct.c jdmarker.c jdmaster.c
	jdmerge.c jdpostct.c jdsample.c jdtrans.c jerror.c jfdctflt.c
	jfdctfst.c jfdctint.c jidctflt.c jidctfst.c jidctint.c jquant1.c
	jquant2.c jutils.c jmemmgr.c jmemnobs.c
)
LIST_ITEMS_PREPEND(libjpeg_sources "${JPEG_DIR}/")

CONFIGURE_FILE("${JPEG_DIR}/jconfig.vc" "${JPEG_DIR}/jconfig.h" COPYONLY)

ADD_LIBRARY(jpeg STATIC ${libjpeg_sources})

GET_TARGET_PROPERTY(jpeg_location jpeg LOCATION)
ADD_CUSTOM_COMMAND(
	TARGET jpeg POST_BUILD
	COMMAND ${CMAKE_COMMAND} -E copy
	"${jpeg_location}" "${JPEG_DIR}/"
)


#=================================== ZLIB ===================================#

SET(
	zlib_sources
	adler32.c compress.c crc32.c deflate.c inffast.c inflate.c
	inftrees.c trees.c uncompr.c zutil.c
)
LIST_ITEMS_PREPEND(zlib_sources "${ZLIB_DIR}/")

ADD_LIBRARY(zlib STATIC ${zlib_sources})
SET_TARGET_PROPERTIES(zlib PROPERTIES OUTPUT_NAME z)
GET_TARGET_PROPERTY(zlib_location zlib LOCATION)
ADD_CUSTOM_COMMAND(
	TARGET zlib POST_BUILD
	COMMAND ${CMAKE_COMMAND} -E copy
	"${zlib_location}" "${ZLIB_DIR}/"
)


#================================== LIBPNG ==================================#

INCLUDE_DIRECTORIES(${ZLIB_DIR})

SET(
	libpng_sources
	png.c pngset.c pngget.c pngrutil.c pngtrans.c pngwutil.c pngread.c
	pngrio.c pngwio.c pngwrite.c pngrtran.c pngwtran.c pngmem.c
	pngerror.c pngpread.c
)
LIST_ITEMS_PREPEND(libpng_sources "${PNG_DIR}/")

ADD_LIBRARY(png STATIC ${libpng_sources})
GET_TARGET_PROPERTY(png_location png LOCATION)
ADD_CUSTOM_COMMAND(
	TARGET png POST_BUILD
	COMMAND ${CMAKE_COMMAND} -E copy
	"${png_location}" "${PNG_DIR}/"
)


#=================================== TIFF ===================================#

INCLUDE_DIRECTORIES(${JPEG_DIR}) # ZLIB_DIR already included above

SET(
	tiff_definitions
	-DAVOID_WIN32_FILEIO -DLIBTIFF_STATIC
)

SET(
	libtiff_sources
	tif_aux.c tif_close.c tif_codec.c tif_color.c tif_compress.c
	tif_dir.c tif_dirinfo.c tif_dirread.c tif_dirwrite.c
	tif_dumpmode.c tif_error.c tif_extension.c tif_fax3.c
	tif_fax3sm.c tif_getimage.c tif_jpeg.c tif_ojpeg.c tif_flush.c
	tif_luv.c tif_lzw.c tif_next.c tif_open.c tif_packbits.c
	tif_pixarlog.c tif_predict.c tif_print.c tif_read.c tif_swab.c
	tif_strip.c tif_thunder.c tif_tile.c tif_version.c
	tif_warning.c tif_write.c tif_zip.c tif_unix.c
)
LIST_ITEMS_PREPEND(libtiff_sources "${TIFF_DIR}/libtiff/")

SET(tiff_vc_config "${TIFF_DIR}/libtiff/tif_config.vc.h")
IF(EXISTS "${TIFF_DIR}/libtiff/tif_config.h.vc")
	SET(tiff_vc_config "${TIFF_DIR}/libtiff/tif_config.h.vc")
ENDIF(EXISTS "${TIFF_DIR}/libtiff/tif_config.h.vc")
CONFIGURE_FILE(
	"${tiff_vc_config}" "${TIFF_DIR}/libtiff/tif_config.h" @COPYONLY
)
IF(EXISTS "${TIFF_DIR}/libtiff/tiffconf.vc.h")
	CONFIGURE_FILE(
		"${TIFF_DIR}/libtiff/tiffconf.vc.h"
		"${TIFF_DIR}/libtiff/tiffconf.h" @COPYONLY
`	)
ENDIF(EXISTS "${TIFF_DIR}/libtiff/tiffconf.vc.h")

ADD_DEFINITIONS(${tiff_definitions})
ADD_LIBRARY(tiff STATIC ${libtiff_sources})

GET_TARGET_PROPERTY(tiff_location tiff LOCATION)
ADD_CUSTOM_COMMAND(
	TARGET tiff POST_BUILD
	COMMAND ${CMAKE_COMMAND} -E copy
	"${tiff_location}" "${TIFF_DIR}/libtiff/"
)


#================================= Boost ================================#

IF(MINGW)
	SET(boost_toolset gcc)
ELSEIF(MSVC)
	SET(boost_toolset msvc)
ELSE(MINGW)
	MESSAGE(FATAL_ERROR "Unsupported platform.  MinGW and MSVC are supported.")
ENDIF(MINGW)

ADD_CUSTOM_TARGET(
	boost "${BJAM_EXECUTABLE}" --with-test toolset=${boost_toolset}
	threading=multi link=static variant=debug,release
	define=_BIND_TO_CURRENT_VCLIBS_VERSION=1
	stage
	WORKING_DIRECTORY "${BOOST_DIR}"
)


#=================================== Qt ===================================#

# Backward compatibility.  We used to patch projects.pro, but now we achieve
# the same result by other means.
IF(EXISTS "${QT_DIR}/projects.pro.orig")
	CONFIGURE_FILE(
		"${QT_DIR}/projects.pro.orig"
		"${QT_DIR}/projects.pro" COPYONLY
	)
	FILE(REMOVE "${QT_DIR}/projects.pro.orig")
ENDIF(EXISTS "${QT_DIR}/projects.pro.orig")


TO_NATIVE_PATH("${JPEG_DIR}" JPEG_INCLUDE_DIR)
TO_NATIVE_PATH("${ZLIB_DIR}" ZLIB_INCLUDE_DIR)
TO_NATIVE_PATH("${PNG_DIR}" PNG_INCLUDE_DIR)
TO_NATIVE_PATH("${QT_DIR}" QT_DIR_NATIVE)

# Find all *.pro files under tools/ and patch those that mention qjpeg
# but not libjpeg.  Patching is necessary to make those tools compile
# with static and external libjpeg.
FILE(GLOB_RECURSE pro_files "${QT_DIR}/tools/*.pro")
FOREACH(file_pro ${pro_files})
	FILE(READ "${file_pro}" contents)
	IF(contents MATCHES qjpeg AND NOT contents MATCHES libjpeg)
		# Make a backup copy, if not already there.
		IF(NOT EXISTS "${file_pro}.orig")
			CONFIGURE_FILE("${file_pro}" "${file_pro}.orig" COPYONLY)
		ENDIF(NOT EXISTS "${file_pro}.orig")

		FILE(APPEND "${file_pro}" "\nwin32 {\n\tLIBS += libjpeg.lib\n}\n")
	ENDIF(contents MATCHES qjpeg AND NOT contents MATCHES libjpeg)
ENDFOREACH(file_pro)

# Find all *.conf files under mkspecs that mention -Zc:wchar_t- and remove
# that minus at the end.  That's necessary to make Qt compatible with other
# libraries that use wchar_t stuff.
FILE(GLOB_RECURSE conf_files "${QT_DIR}/mkspecs/*.conf")
FOREACH(conf_file ${conf_files})
	FILE(READ "${conf_file}" contents)
	STRING(REGEX REPLACE "-Zc:wchar_t-" "-Zc:wchar_t" new_contents "${contents}")
	IF(NOT "${contents}" STREQUAL "${new_contents}")
		# Make a backup copy, if not already there.
		IF(NOT EXISTS "${conf_file}.orig")
			CONFIGURE_FILE("${conf_file}" "${conf_file}.orig" COPYONLY)
		ENDIF()

		FILE(WRITE "${conf_file}" "${new_contents}")
	ENDIF()
ENDFOREACH()

SET(qt_maybe_skip_tools)
IF(EXISTS "${QT_DIR}/bin/designer.exe")
	# Either the tools have already been built, or they came prepackaged.
	SET(qt_maybe_skip_tools "-nomake tools")
ENDIF(EXISTS "${QT_DIR}/bin/designer.exe")

IF(MINGW)
	SET(platform win32-g++)
	SET(make_command mingw32-make)
ELSEIF(MSVC)
	SET(make_command nmake)
	IF(MSVC60 OR MSVC70)
		MESSAGE(FATAL_ERROR "This Visual Studio version is too old and is not supported")
	ELSEIF(MSVC71)
		SET(platform win32-msvc2003)
	ELSEIF(MSVC80)
		SET(platform win32-msvc2005)
		SET(force_frame_pointer TRUE)
	ELSE(MSVC60 OR MSVC70)
		#MSVC90 or above
		SET(platform win32-msvc2008)
		SET(force_frame_pointer TRUE)
	ENDIF(MSVC60 OR MSVC70)
ELSE(MINGW)
	MESSAGE(FATAL_ERROR "Unsupported platform.")
ENDIF(MINGW)

# We disable frame pointer ommission in release mode to ensure
# good stack traces from our built-in crash reporter.
IF(MSVC AND force_frame_pointer)
	SET(conf_file "${QT_DIR}/mkspecs/${platform}/qmake.conf")
	FILE(READ "${conf_file}" contents)
	STRING(REGEX REPLACE "(QMAKE_CFLAGS_RELEASE[ \\t]*=)" "\\1 -Oy-" new_contents "${contents}")
	STRING(REGEX REPLACE "( -Oy-)+" " -Oy-" new_contents "${new_contents}")
	IF(NOT "${contents}" STREQUAL "${new_contents}")
		# Make a backup copy, if not already there.
		IF(NOT EXISTS "${conf_file}.orig")
			CONFIGURE_FILE("${conf_file}" "${conf_file}.orig" COPYONLY)
		ENDIF()

		FILE(WRITE "${conf_file}" "${new_contents}")
	ENDIF()
ENDIF()

# Note #1: -system-zlib is broken on Windows (bug: #186774).  So, we build with
# internal zlib, while libpng is linked with an external one.  This works only
# because both zlib's have the same ABI.
# Note #2: We build with -no-libtiff because we have our own TIFF loading
# and saving code.  Qt's TIFF plugin has way too many limitations.
SET(build_qt_fname "${CMAKE_CURRENT_BINARY_DIR}/build-qt.bat")
FILE(
	WRITE "${build_qt_fname}"
	"cd \"${QT_DIR_NATIVE}\"\n"
	"configure -platform ${platform} -debug-and-release -static -fast"
	" -no-gif -system-libpng -no-libmng -no-libtiff -system-libjpeg"
	" -no-openssl -no-qt3support -no-style-plastique -no-style-cleanlooks"
	" -no-style-motif -no-style-cde -no-phonon -no-webkit -no-scripttools"
	" -nomake examples -nomake demos -nomake docs ${qt_maybe_skip_tools}"
	" -opensource -confirm-license -no-ltcg"
	" -I \"${JPEG_INCLUDE_DIR}\" -I \"${ZLIB_INCLUDE_DIR}\""

=== debian/changelog ===
scantailor (0.9.9.2-0ubuntu2) natty; urgency=low

  * Really drop ia64 and sparc arches (change went missing in previous
    upload)

 -- Bhavani Shankar <bhavi@ubuntu.com>  Fri, 26 Nov 2010 17:32:49 +0530

scantailor (0.9.9.2-0ubuntu1) natty; urgency=low

  * New upstream release
  * Bump standards t0 3.9.1
  * Drop support for ia64 and sparc as they are no longer supported

 -- Bhavani Shankar <bhavi@ubuntu.com>  Fri, 26 Nov 2010 12:15:40 +0530

scantailor (0.9.9-0ubuntu2) natty; urgency=low

  * Bump Boost build-dep to libboost-test1.42-dev
  * Add Xrender to CMAKE_EXE_LINKER_FLAGS to fix FTBFS due to indirect linking

 -- Scott Kitterman <scott@kitterman.com>  Sat, 16 Oct 2010 15:21:41 -0400

=== debian/control ===
--- 
+++ 
@@ -5,12 +5,12 @@
 XSBC-Original-Maintainer: Артём Попов <artfwo@gmail.com>
 Build-Depends: cdbs, debhelper (>= 5), cmake (>= 2.6.0),
  libqt4-dev (>= 4.4.0), libjpeg62-dev, libpng12-dev, libtiff4-dev,
- libboost-test1.40-dev, libxrender-dev
-Standards-Version: 3.8.4
+ libboost-test1.42-dev, libxrender-dev
+Standards-Version: 3.9.1
 Homepage: http://scantailor.sourceforge.net/
 
 Package: scantailor
-Architecture: amd64 i386 ia64 powerpc sparc
+Architecture: amd64 i386 powerpc 
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Interactive post-processing tool for scanned pages
  Scan Tailor is an interactive post-processing tool for scanned pages. It
